#include <bits/stdc++.h>

using namespace std;

int main() {
    ifstream cin("cursuri.in");
    ofstream cout("cursuri.out");
    int n, k, t;
    cin >> n >> k >> t;
    vector<pair<int, int>> b(n);
    for (auto& [end, start] : b)
        cin >> start >> end;

    auto solve = [&](int m, int t) {
        multiset<int, greater<int>> last;
        while (m--)
            last.emplace(0);
        auto a = b;
        for (auto& [x, y] : a)
            x += t;
        int ans = 0;
        sort(a.begin(), a.end());
        for (auto& [end, start] : a) {
            auto it = last.lower_bound(start);
            if (it != last.end()) {
                last.erase(it);
                last.emplace(end);
                ++ans;
            }
        }
        return ans;
    };

    int left = 1, right = k;
    while (left < right) {
        int m = (left + right) / 2;
        if (solve(m, t) >= k)
            right = m;
        else
            left = m + 1;
    }
    int nr = left;

    left = t, right = 1e9;
    while (left < right) {
        int m = (left + right + 1) / 2;
        if (solve(nr, m) >= k)
            left = m;
        else
            right = m - 1;
    }

    int delay = left == 1e9 ? -1 : left;
    cout << nr << ' ' << delay;
}